#include "processor.inc"
#include "autop_defines.inc"

PROG1 	CODE

	EXTERN	rect_to_polar, MULS2X2

navigate

	btfss	returnM
	bra		nav_circle

	movff xWorldH,X_rectH
	movff xWorldL,X_rectL
	movff yWorldH,Y_rectH
	movff yWorldL,Y_rectL

	rcall rect_to_polar
	movf 	THETA, w

	addlw 0x80		; come home	angle, inward

	movwf	desiredDir	

	return

nav_circle
	
	btfss	circlingM
	return

	movff xWorldH,X_rectH
	movff xWorldL,X_rectL
	movff yWorldH,Y_rectH
	movff yWorldL,Y_rectL

	movf xFocusL,w
	subwf X_rectL,f
	movf xFocusH,w
	subwfb X_rectH,f
	movf yFocusL,w
	subwf Y_rectL,f
	movf yFocusH,w
	subwfb Y_rectH,f

	rcall rect_to_polar
	movf 	THETA, w

	addlw 0x80		; come home	angle, inward

	movwf	desiredDir	

	return
	

	GLOBAL	navigate

	end	
