; options, 1 selects, 0 deselects

;#define	truck 0 ; truck related options
;#define plane 1 ; sailplane related options

#if ( plane ==1 )

#define	enablemixser	1		;	elevator adjusted for rudder and bank
#define	enablemixgyr	1		;	pitch adjusted for yaw and bank
#define	enablenav		1		;	GPS navigation
#define	enablegyr		1		;	gyro feedback
#define	enableacc		1		;	accelerometer feedback
#define radioCheck		1		;	radio must be on
#define	enableaug		1		;	computer assisted manual flight
#define	rvrspitch		0		;	reverse the pitch sensors
#define	filteraccel		1		;	filter the accelerometers
#define	skipgpscheck	0		;	skip the GPS check
#define	SELFTEST		0		;	enable the sensor selftest
#define	accelMAV		1		;	moving average filter for y accel


#define	cpuUsage		0	;	option to use LED to estimate CPU usage

#define	banktau		.13	;	0.4 seconds banking time constant

#if ( enablemixser == 1)
#define	mixgain0			0x0D	;	rudder-elevator mixing, about right
#else
#define mixgain0			0x00
#endif

#if ( enablemixgyr == 1)
#define	mixgyr0	0x30		;	gyro decoupling gain without accel MAV
;#define	mixgyr0	0x18		;	gyro decoupling gain with accel MAV
#else
#define	mixgyr0	0x00
#endif

#if ( rvrspitch == 1)
#define 	pitchgainl	0x30	;	pitch gyro gain without accel MAV
;#define 	pitchgainl	0x18	;	pitch gyro gain with accel MAV
#if ( accelMAV == 1)
#define	accelgainl	-0x03
#else
#define	accelgainl	-0x0C	;
#endif	
;#define	accelgainl	-0x30

#else

#define pitchgainl	-0x30	;
;#define pitchgainl	-0x18	;
#if	( accelMAV == 1)	
#define	accelgainl	0x03
#else
#define	accelgainl	0x0C	;
#endif	
;#define		accelgainl	0x30	;
#endif

#if ( enableacc == 1)
#define	accelgain0		accelgainl	;	pitch accel gain
#else
#define	accelgain0		0		;	pitch accel gain
#endif



#if	( enablegyr ==1 )
#define	pitchgain0		pitchgainl	;	pitch gyro gain
#define	yawgain0		0x30		;	was stable, lets try something a little more aggressive?
;#define	yawgain0		0x40		;	more aggressive
#else
#define	pitchgain0		0		;	pitch gyro gain
#define	yawgain0		0		;	yaw gyro gain
#endif

#if ( enablenav == 1)
;#define	steering_gain0	0x10	;	compensated steering gain
#define	steering_gain0	0x20	;	was stable, let try something more aggressive.
;#define	steering_gain0	0x30	;	more aggressive.
#else
#define	steering_gain0	0		;	compensated steering gain
#endif

#if	( enableaug == 1)
#define	auggain0		0x40	; was ok, lets try something a bit more aggressive?
;#define	auggain0		0x60 ;	more aggressive
#else
#define	auggain0		0x00
#endif

;#define	navGain	.0					;	turns off navigation angle correction
#define minRadiusX4		.200		;	navigation angle correction radius

;#define pw_short_long	0x05

#define	calib_pause		0x08
#define	standby_pause	0x08
#define	auto_pulse		0x15
#define	circle_pulse	0xC5

#define	waggle0			0x20

#define tst_mode_menu 0 ; menu to enter test mode work without GPS
#define gps_menu 0 ; menu to display GPS, set origin
#define vtg_menu 0 ;  display vtg info
#define	xy_menu 0 ; display relative offset, set 2nd focus

#endif


#define statusLED 1	;	use LEDs to display status
#define cmpsLED 0 ;	output compass on port A LED
#define GPSDEBUG 0 ; GSP RX test

